#include <windows.h>
#include <tchar.h>
#include <commctrl.h>

#include "ITetrisMgr.h"

// Defines
#define BLOCK_SIZE 36                     // 1ubN̑傫(pixel)
#define TETRIS_TIMER_FALL   100           // 鎞Ԃv^C}ID
#define TETRIS_TIMER_BTNCHK 101           // {^͂`FbN^C}ID
#define TETRIS_BTNCHK_INTERVAL (1000/30)  // {^̓`FbN̎ԊԊu

// Global
static HINSTANCE g_hInstance;    // ̃AvP[VHINSTANCE
static HWND g_hMainWindow;       // CEChẼnh
static HBITMAP g_hMemBitmap;     // _uobt@OpBitmapIuWFNg
static HIMAGELIST g_hImageList;  // C[WXg̃nh
static ITetrisMgr *g_pTetrisMgr; // TetrisMgrIuWFNgւ̃|C^

// bZ[Wnh
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch(msg) {
		case WM_CREATE: {
			InitCommonControls(); // C[WXgg߂ɕKv炵

			HDC hdc = GetDC(hWnd);
			// _uobt@OpBitmap쐬
			g_hMemBitmap = CreateCompatibleBitmap(hdc, BLOCK_SIZE * TETRIS_BLOCKNUM_X, BLOCK_SIZE * TETRIS_BLOCKNUM_Y);
			// ubÑC[WXg쐬
			HBITMAP hBitmap = LoadBitmap(g_hInstance, _T("BLOCKS"));
			g_hImageList = ImageList_Create(BLOCK_SIZE, BLOCK_SIZE, ILC_COLOR, BLOCKSTATE_NUM, 0);
			ImageList_Add(g_hImageList, hBitmap, NULL);
			DeleteObject(hBitmap);
			
			ReleaseDC(hWnd, hdc);
			break;
		}
		case WM_TIMER: {
			unsigned int nFallIntervalPre = g_pTetrisMgr->GetFallTimerInterval();

			// wParam̒lŁAǂ̃^C}[ɂ郁bZ[W
			switch(wParam){
			case TETRIS_TIMER_BTNCHK:
				// ZԊԊuŁÃL[Ă邩̃`FbNsĂ
				// Ăꍇɂ́ATetrisMgrɂ̎|ʒmAĕ`悷悤Ɏw
				if(GetAsyncKeyState(VK_LEFT) & 0x8000){
					g_pTetrisMgr->OnLeft();
					InvalidateRect(hWnd, NULL, false);
				}else if(GetAsyncKeyState(VK_RIGHT) & 0x8000){
					g_pTetrisMgr->OnRight();
					InvalidateRect(hWnd, NULL, false);
				}else if(GetAsyncKeyState(VK_UP) & 0x8000){
					g_pTetrisMgr->OnLRotate();
					InvalidateRect(hWnd, NULL, false);
				}else if(GetAsyncKeyState(VK_DOWN) & 0x8000){
					g_pTetrisMgr->OnDown();
					InvalidateRect(hWnd, NULL, false);
				}else if(GetAsyncKeyState('Z') & 0x8000){
					g_pTetrisMgr->OnLRotate();
					InvalidateRect(hWnd, NULL, false);
				}else if(GetAsyncKeyState('X') & 0x8000){
					g_pTetrisMgr->OnRRotate();
					InvalidateRect(hWnd, NULL, false);
				}
				break;
			case TETRIS_TIMER_FALL:
				// P}X鎞Ԃ̃^C}[̏ꍇ
				g_pTetrisMgr->OnFall();
				InvalidateRect(hWnd, NULL, false);
				break;
			default:
				break;
			}
			if(g_pTetrisMgr->IsGameOver()){
				// Q[I[o[ƕꍇ̏s
				// ^C}[~
				KillTimer(g_hMainWindow, TETRIS_TIMER_FALL);
				KillTimer(g_hMainWindow, TETRIS_TIMER_BTNCHK);
				// bZ[W{bNXoāA[U[ɏI邩ǂIĂ炤
				if(MessageBox(g_hMainWindow, _T("Game Over... Retry?"), _T("Game Over"), MB_OKCANCEL | MB_ICONINFORMATION) == IDOK){
					// ēxX^[g̏ꍇ
					// TetrisMgrɏʒm
					g_pTetrisMgr->OnInit();
					g_pTetrisMgr->OnStart();
					InvalidateRect(hWnd, NULL, false); // ĕ`w
					// ^C}[ăX^[g
					SetTimer(g_hMainWindow, TETRIS_TIMER_FALL, g_pTetrisMgr->GetFallTimerInterval(), NULL);
					SetTimer(g_hMainWindow, TETRIS_TIMER_BTNCHK, TETRIS_BTNCHK_INTERVAL, NULL);
				}else{
					// Î߂̃bZ[W𓊂
					PostMessage(g_hMainWindow, WM_CLOSE, 0, 0);
				}
			}else if(nFallIntervalPre != g_pTetrisMgr->GetFallTimerInterval()){
				// TetrisMgrwA鎞ԊԊuύXɂȂ
				// x^C}[~߂āAԕύXčăX^[gĂ
				KillTimer(g_hMainWindow, TETRIS_TIMER_FALL);
				SetTimer(g_hMainWindow, TETRIS_TIMER_FALL, g_pTetrisMgr->GetFallTimerInterval(), NULL);
			}
			break;
		}
		case WM_PAINT: {
			// EChE̕`揈
			// Windows̕`揈́ÃbZ[Wɂ̂ݍsA
			// ̃bZ[W̏ɕ`悷邱Ƃ͍sȂ悤Ɏ̂
			// ĕ`x̂ȂAInvalidateRectgΗǂ
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hWnd, &ps);

			// _uobt@Ô߂Bitmapɕ`߂DC𐶐
			// ڃEChEɃubN`Ă܂ƁAubN`Ăߒ
			// Ă܂ĉ̂ŁAxŃubN`A
			// xɃEChEɕ`悷悤Ɏ
			HDC hMemDC = CreateCompatibleDC(hdc);
			SaveDC(hMemDC);
			SelectObject(hMemDC, g_hMemBitmap);

			for(int x = 0; x < TETRIS_BLOCKNUM_X; x++) {
				for(int y = 0; y < TETRIS_BLOCKNUM_Y; y++) {
					// C[WXgPubN̉摜𔲂oĕ`
					ImageList_Draw(g_hImageList, (int)g_pTetrisMgr->GetBlockState(x, y),
						hMemDC, x * BLOCK_SIZE, y * BLOCK_SIZE, ILD_NORMAL);
				}
			}

			// `BitmapWindowɈCɕ`悷
			BitBlt(hdc, 0, 0, BLOCK_SIZE * TETRIS_BLOCKNUM_X, BLOCK_SIZE * TETRIS_BLOCKNUM_Y, hMemDC, 0, 0, SRCCOPY);
			RestoreDC(hMemDC, -1);
			DeleteObject(hMemDC);

			EndPaint(hWnd, &ps);
			break;
		}
		case WM_DESTROY: {
			// Ȉ
			ImageList_Destroy(g_hImageList);
			DeleteObject(g_hMemBitmap);
			
			PostQuitMessage(0);
			break;
		}
		default:
			return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}

int APIENTRY _tWinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPTSTR cmdLine, int cmdShow)
{
    g_hInstance = hInst;

	// TetrisMgr𓾂
	g_pTetrisMgr = GetTetrisMgr();
	if(!g_pTetrisMgr){
		return -1;
	}
	g_pTetrisMgr->OnInit();
	g_pTetrisMgr->OnStart();

	WNDCLASSEX wc;                                 // `p̍\
	static LPCTSTR pClassName = _T("Tetris");      // NX

	wc.cbSize        = sizeof(WNDCLASSEX);         // \̃TCY
	wc.style         = CS_HREDRAW | CS_VREDRAW;    // NXX^C
	wc.lpfnWndProc   = (WNDPROC)WndProc;
	wc.cbClsExtra    = 0;                          // ⑫ubN
	wc.cbWndExtra    = 0;                          //   ̃TCY
	wc.hInstance     = hInst;                      // CX^X
	wc.hIcon         = NULL;
	wc.hCursor       = LoadCursor(NULL,IDC_ARROW); // J[\
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);   // wiF
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = pClassName;                 // NX
	wc.hIconSm       = NULL;
	if (!RegisterClassEx(&wc)) return FALSE;       // o^

	// NCAg̈̈ʒuƃTCY̎w肩A
	// ̏𖞂߂ɕKvȁAEBhËʒuƃTCYvZ
	RECT r;
	r.left = r.top = 0;
	r.right = BLOCK_SIZE * TETRIS_BLOCKNUM_X;
	r.bottom = BLOCK_SIZE * TETRIS_BLOCKNUM_Y;
	AdjustWindowRectEx(&r, WS_OVERLAPPED | WS_MINIMIZEBOX | WS_SYSMENU | WS_CAPTION, false, 0);

	// EChE
	g_hMainWindow = CreateWindow(pClassName, _T("Tetris"), WS_OVERLAPPED | WS_MINIMIZEBOX | WS_SYSMENU | WS_CAPTION,
    				CW_USEDEFAULT, CW_USEDEFAULT, r.right - r.left, r.bottom - r.top,
    				NULL, NULL, hInst, NULL);
	ShowWindow(g_hMainWindow, SW_SHOW);

	// ^C}[X^[g
	SetTimer(g_hMainWindow, TETRIS_TIMER_FALL, g_pTetrisMgr->GetFallTimerInterval(), NULL);
	SetTimer(g_hMainWindow, TETRIS_TIMER_BTNCHK, TETRIS_BTNCHK_INTERVAL, NULL);

	// bZ[WfBXpb`
	MSG msg;
	while(GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	KillTimer(g_hMainWindow, TETRIS_TIMER_FALL);
	KillTimer(g_hMainWindow, TETRIS_TIMER_BTNCHK);

	ReleaseTetrisMgr(g_pTetrisMgr);
	g_pTetrisMgr = NULL;

	return 0;
}
